package com.supervision.qanything.impl;

import cn.hutool.core.lang.TypeReference;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.json.JSONUtil;
import com.supervision.qanything.QanythingService;
import com.supervision.qanything.dto.ChatParam;
import com.supervision.qanything.dto.ChatResult;
import com.supervision.qanything.dto.ResultWrapper;
import com.supervision.qanything.util.AuthV3Util;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.security.NoSuchAlgorithmException;
import java.util.List;

@Slf4j
@Service
@RequiredArgsConstructor
public class QanythingServiceImpl implements QanythingService {

    @Value("${youdao.qanthing.appKey}")
    private String APP_KEY;

    @Value("${youdao.qanthing.appSecret}")
    private String APP_SECRET;

    @Value("${youdao.qanthing.baseUrl}")
    private String BASE_URL = "https://openapi.youdao.com";
    @Override
    public ResultWrapper<ChatResult> chat(String question, List<String> kbIds) throws NoSuchAlgorithmException {
        ChatParam chatParam = new ChatParam();
        chatParam.setQ(question);
        chatParam.setKbIds(kbIds);
        // 添加鉴权相关参数
        AuthV3Util.addAuthParams(APP_KEY, APP_SECRET, chatParam);
        HttpRequest request = HttpRequest.post(BASE_URL + "/q_anything/paas/chat")
                .body(JSONUtil.toJsonStr(chatParam));
        try (HttpResponse response = request.execute()){
            return JSONUtil.toBean(response.body(), new TypeReference<ResultWrapper<ChatResult>>(){},true);
        }
    }


}
